-- Speccy's abilities.

freeslot(
	"SPR2_DIVE",
	"S_NSPECCY_DIVE",
	"SPR2_SLID",
	"S_NSPECCY_SLIDE",
	"SPR2_CRAW",
	"S_NSPECCY_CRAWL",
	"SPR2_CROU",
	"S_NSPECCY_CROUCH",
	"SPR2_LOIS",
	"S_NLOIS"
)

states[S_NSPECCY_DIVE] = {
	sprite = SPR_PLAY,
	frame = SPR2_DIVE|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_SLIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SLID|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_CROUCH] = {
	sprite = SPR_PLAY,
	frame = SPR2_CROU|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_CRAWL] = {
	sprite = SPR_PLAY,
	frame = SPR2_CRAW|FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 7,
	nextstate = S_NULL
}

states[S_NLOIS] = {
	sprite = SPR_PLAY,
	frame = SPR2_LOIS|A,
	tics = -1,
	nextstate = S_NULL
}

local speccycbutton = BT_CUSTOM3
local speccydbutton = BT_USE

local buttons = {BT_USE, BT_CUSTOM1, BT_CUSTOM2, BT_CUSTOM3}

COM_AddCommand("speccy_remap", function(p, arg, arg2)
	if arg == nil or (arg ~= "dive" and arg ~= "crouch") then
		CONS_Printf(p, "speccy_remap:\n - Usage: speccy_remap <move> <button>\n\nMoves:\n - dive: Dive/Roll\n - crouch: Crouch\n\nButtons:\n - 1: Spin\n - 2: Custom 1\n - 3: Custom 2\n - 4: Custom 3")
	else
		if tonumber(arg2) ~= nil then
			arg2 = tonumber(arg2)
			if arg == "dive" then
				speccydbutton = buttons[arg2]
			elseif arg == "crouch" then
				speccycbutton = buttons[arg2]
			end
		else
			CONS_Printf(p, "speccy_remap:\n - Usage: speccy_remap <move> <button>\n\nMoves:\n - dive: Dive/Roll\n - crouch: Crouch\n\nButtons:\n - 1: Spin\n - 2: Custom 1\n - 3: Custom 2\n - 4: Custom 3")
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	p.speccydive = false
	p.speccycrouch = false
	p.speccyroll = false
	p.speccylois = false
	p.speccydiveangle = p.drawangle
	p.speccyjumptimer = 0
end)

local function speccyCanCrouch(p)
	if not(p.mo and p.mo.valid) then return false end
	if p.mo.skin ~= "speccy" then return false end
	if not(p.cmd.buttons & speccycbutton) then return false end
	if not P_IsObjectOnGround(p.mo) then return false end
	if P_PlayerInPain(p) then return false end
	if p.speccyroll then return false end
	return true
end

local function CrouchHeight(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccycrouch or p.speccydiving or (p.pflags & PF_SPINNING) then
		return skins[p.mo.skin].height/2
	else
		return skins[p.mo.skin].height
	end
end

local function CrouchGap(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccycrouch then
		return true
	end
end

addHook("PlayerHeight", CrouchHeight)
addHook("PlayerCanEnterSpinGaps", CrouchGap)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if not (p.cmd.buttons & speccydbutton) then
		p.speccyspinready = true
		p.speccyspintap = false
	elseif p.speccyspinready then
		p.speccyspinready = false
		p.speccyspintap = true
	else
		p.speccyspintap = false
	end
	
	if not (p.cmd.buttons & BT_TOSSFLAG) then
		p.speccyloisready = true
		p.speccyloistap = false
	elseif p.speccyloisready then
		p.speccyloisready = false
		p.speccyloistap = true
	else
		p.speccyloistap = false
	end
	
	if p.speccyloistap then
		if P_RandomRange(1,64) == 1 then
			p.speccylois = true
		end
	end
	
	if speccyCanCrouch(p) then
		p.speccycrouch = true
		p.pflags = $|PF_JUMPSTASIS
		p.normalspeed = 4*FRACUNIT
		if (p.speed-abs(p.mo.momz)) > 0 then
			if p.mo.state ~= S_NSPECCY_CRAWL then
				p.mo.state = S_NSPECCY_CRAWL
			end
			p.speccyjumptimer = 0
		else
			p.mo.state = S_NSPECCY_CROUCH
			if P_IsObjectOnGround(p.mo) then
				p.speccyjumptimer = $ + 1
			else
				p.speccyjumptimer = 0
			end
			if p.speccyjumptimer == 52 then 
				S_StartSound(p.mo, sfx_s3ka2, p)
			end
			
			if p.speccyjumptimer >= 52 then 
				if leveltime % 8 == 0 then
					p.mo.colorized = true
				else
					p.mo.colorized = false
				end
			else
				p.mo.colorized = false
			end
		end
		if p.speccyspintap then
			p.pflags = $|PF_SPINNING
			p.pflags = $ & ~PF_JUMPSTASIS
			P_InstaThrust(p.mo, p.drawangle, 24*FRACUNIT)
			S_StartSound(p.mo, sfx_spin, p)
			p.normalspeed = skins[p.mo.skin].normalspeed
			p.mo.state = S_PLAY_ROLL
			p.speccyroll = true
			p.speccycrouch = false
			p.mo.colorized = false
			p.speccyjumptimer = 0
			return
		end
		if p.cmd.buttons & BT_JUMP then
			if p.speccyjumptimer >= 52 then
				p.speccycrouch = false
				p.pflags = $ & ~PF_JUMPSTASIS
				P_SetObjectMomZ(p.mo, p.jumpfactor*16, false)
				S_StartSound(p.mo, sfx_cdfm02, p)
				p.normalspeed = skins[p.mo.skin].normalspeed
				p.mo.state = S_PLAY_ROLL
				p.mo.colorized = false
				p.speccyjumptimer = 0
			end
		end
	else
		if p.speccycrouch then
			p.mo.state = S_PLAY_STND
			p.normalspeed = skins[p.mo.skin].normalspeed
			p.pflags = $ & ~PF_JUMPSTASIS
			p.mo.colorized = false
			p.speccyjumptimer = 0
		end
		p.speccycrouch = false
	end
	
	if p.speccyroll then
		if (p.pflags & PF_JUMPED) or ((p.mo.eflags & MFE_SPRUNG) and p.mo.momz ~= 0) or p.powers[pw_carry] or p.speed < FRACUNIT or P_PlayerInPain(p) then
			p.speccyroll = false
			p.pflags = $ & ~PF_SPINNING
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_WALK
			end
			return
		end
		p.pflags = $|PF_SPINNING
		p.mo.state = S_PLAY_ROLL
		if p.speccyspintap and P_IsObjectOnGround(p.mo) then
			P_Thrust(p.mo, p.drawangle, FRACUNIT/17)
			if p.powers[pw_underwater] then
				P_SetObjectMomZ(p.mo, 2*FRACUNIT, false)
			else
				P_SetObjectMomZ(p.mo, 4*FRACUNIT, false)
			end
		end
	end
	
	if p.speccydive then
		if (p.pflags & PF_JUMPED) or (p.mo.eflags & MFE_SPRUNG) or p.powers[pw_carry] or p.speed < FRACUNIT or P_PlayerInPain(p) then
			p.speccydive = false
			p.pflags = $ & ~PF_SPINNING
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_WALK
			end
			return
		end
		p.pflags = $|PF_SPINNING
		p.diveangle = p.speccydiveangle
		if P_IsObjectOnGround(p.mo) then
			p.mo.state = S_NSPECCY_SLIDE
			P_SpawnSkidDust(p, p.mo.radius/2, true)
			P_Thrust(p.mo, p.speccydiveangle, -FRACUNIT/8)
		else
			p.mo.state = S_NSPECCY_DIVE
		end
	end
	
	if p.speccylois then
		p.mo.state = S_NLOIS
	end
end)

addHook("JumpSpecial", function(p)
	if p.mo.skin ~= "speccy" then return end
	if p.speccydive and P_IsObjectOnGround(p.mo) then
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 3*FRACUNIT, false)
		else
			P_SetObjectMomZ(p.mo, 6*FRACUNIT, false)
		end
		p.mo.state = S_PLAY_ROLL
		p.speccydive = false
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_SPINNING
		return true
	end
end)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if not p.speccyspintap then return end
	if p.speccycrouch or p.speccycrawl or p.speccyroll then return end
	if p.speed < 8*FRACUNIT then return end
	if p.speccydive then
		if not P_IsObjectOnGround(p.mo) then return end
		P_Thrust(p.mo, p.speccydiveangle, FRACUNIT/17)
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 2*FRACUNIT, false)
		else
			P_SetObjectMomZ(p.mo, 5*FRACUNIT, false)
		end
	else
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 3*FRACUNIT, false)
		else
			P_SetObjectMomZ(p.mo, 6*FRACUNIT, false)
		end
		p.speccydiveangle = p.drawangle
		p.mo.state = S_NSPECCY_DIVE
		p.pflags = $ & ~PF_JUMPED
		p.pflags = $|PF_SPINNING
		P_InstaThrust(p.mo, p.speccydiveangle, p.speed)
		p.speccydive = true
	end
end)
 